function w = kaiser(n,beta)

% w=kaiser(n,beta)
% Donne (en colonne) la fenetre de Kaiser de longueur n et 
% de parametre beta. 

nw = round(n);
bes = abs(besseli(0,beta));
odd = rem(nw,2);
xind = (nw-1)^2;
N = fix((nw+1)/2);
xi = (0:N-1) + .5*(1-odd);
xi = 4*xi.^2;
w = besseli(0,beta*sqrt(1-xi/xind))/bes;
w = abs([w(N:-1:odd+1) w])';
